
#include "../melee.h"

Animation::Animation(double ox, double oy, SpaceSprite *osprite,
  int ofcount, int ofsize) :
  SpaceObject(ox, oy, 0.0, -1, osprite),
  frame_count(ofcount),
  frame_size(ofsize),
  frame_step(0)
{
}

void Animation::calculate()
{
  frame_step++;
  if(frame_step == frame_size) {
    frame_step = 0;
    sprite_index++;
    if(sprite_index == frame_count)
      state = 0;
  }
  SpaceObject::calculate();
}

FixedAnimation::FixedAnimation(SpaceLocation *opos, SpaceSprite *osprite,
  int ofcount, int ofsize) :
  Animation(0.0, 0.0, osprite, ofcount, ofsize),
  pos(opos)
{
  if(pos->exists()) {
    x = pos->normal_x();
    y = pos->normal_y();
  } else
    state = 0;
}

void FixedAnimation::calculate()
{
  if(pos->exists()) {
    x = pos->normal_x();
    y = pos->normal_y();
    Animation::calculate();
  } else
    state = 0;
}