
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include <allegro.h>
#include <jgmod.h>
#include <kb.h>
#include "../player.h"
#include "../melee.h"

double space_x;
double space_y;
double space_zoom;
int    space_step;
int    space_div;

double total_frames;
double timed_frames;
double frame_time;

Player *player1, *player2;

Frame *space;
Frame *radar;

ShipPanel *panel1;
ShipPanel *panel2;

SHIP_INFO ship_info[MAX_SHIP_TYPES];
char     *ship_name[MAX_SHIP_TYPES + 1];
int       num_ship_types;

char *fleet_id[MAX_FLEET_SIZE];
char *fleet_name[MAX_FLEET_SIZE];

char fleet_title[80];
int  fleet_size = 0;
int  fleet_cost = 0;

char strEmptySlotID[] = "?????";
char strEmptySlotName[] = "[Empty slot]";

DATAFILE *melee;
DATAFILE *scppal;

int melee_paused;

volatile int melee_time;
volatile int frame_count, fps;

void melee_timer(...)
{
  if(!melee_paused)
    melee_time++;
}

END_OF_FUNCTION(melee_timer);

void fps_proc(...)
{
  fps = frame_count;
  frame_count = 0;
  if (timed_frames) frame_time = total_frames / timed_frames;
  else frame_time = 9999;
  total_frames = 0;
  timed_frames = 0;
}

END_OF_FUNCTION(fps_proc);

char *selectListboxGetter(int index, int *list_size);

#define SELECT_DIALOG_TITLE     0
#define SELECT_DIALOG_LIST      1
#define SELECT_DIALOG_PLAYERBOX 2
#define SELECT_DIALOG_PLAYER    3
#define SELECT_DIALOG_SHIP      4
#define SELECT_DIALOG_RANDOM    5
#define SELECT_DIALOG_ABORT     6

#define VICTORY_DIALOG_TITLE     0
#define VICTORY_DIALOG_LIST      1
#define VICTORY_DIALOG_PLAYERBOX 2
#define VICTORY_DIALOG_PLAYER    3
#define VICTORY_DIALOG_CONTINUE  4

char selectPlayer[18];
char selectTitleString[100];

DIALOG selectDialog[] =
{
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_textbox_proc,    10,   5,    160,  48,   255,  0,    0,    0,       0,    0,    selectTitleString },
  { d_list_proc,       10,   60,   160,  415,  255,  0,    0,    D_EXIT,  0,    0,    selectListboxGetter },
  { d_box_proc,        240,  5,    160,  20,   255,  0,    0,    0,       0,    0,    NULL },
  { d_ctext_proc,      320,  10,   160,  10,   255,  0,    0,    0,       0,    0,    selectPlayer },
  { d_button_proc,     240,  35,   160,  48,   255,  0,    0,    D_EXIT,  0,    0,    "Select ship" },
  { d_button_proc,     240,  95,   160,  48,   255,  0,    0,    D_EXIT,  0,    0,    "Random selection" },
  { d_button_proc,     240,  155,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    "Abort game" },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL }
};

DIALOG victoryDialog[] =
{
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)      (d1)  (d2)  (dp)
  { d_textbox_proc,    10,   5,    160,  48,   255,  0,    0,    0,           0,    0,    selectTitleString },
  { d_list_proc,       10,   60,   160,  415,  255,  0,    0,    D_DISABLED,  0,    0,    selectListboxGetter },
  { d_box_proc,        240,  5,    160,  20,   255,  0,    0,    0,           0,    0,    NULL },
  { d_ctext_proc,      320,  10,   160,  10,   255,  0,    0,    0,           0,    0,    selectPlayer },
  { d_button_proc,     240,  35,   160,  48,   255,  0,    0,    D_EXIT,      0,    0,    "Continue" },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,           0,    0,    NULL }
};

int melee_done;

void       load_ship_data(int index);
void       free_ships(int ship1, int ship2);
ShipPanel *select_ship(int player, int index);
int        ship_idtoindex(char *id_str);

void suspend_melee();
void resume_melee();
int  select_fleet_ship(int player, char *fleet_file, ShipPanel **panel, int fleet_total);
void save_screen_shot();
void show_fleet(int player, char *fleet_file, int fleet_total, int slot);

  char  buf[80];
  int   i;
  int   zoom_discrete;
  int   zoom_antia;
  int   music_key    = FALSE;
  int   show_fps     = FALSE;
  int   show_key     = FALSE;
  int   shot_key     = FALSE;
  int   esc_key      = FALSE;
  int   zoom_key     = FALSE;
  int   antia_key    = TRUE;

void play_frame() {
  int of = melee_time;
  panel1->ship->target = panel2->ship;
  panel2->ship->target = panel1->ship;

  kb_update();

  if(panel1->ship) {
    player1->calculate();
  }

  if(panel2->ship) {
    player2->calculate();
  }

  spaceFrame->calculate();
  spaceFrame->collide();
  panel1->calculate();
  panel2->calculate();

  if (of != melee_time) timed_frames += 1;
  melee_time--;
  total_frames += 1;
}

Stars *stars;

void animate_frame (Stars *stars) {

  if((show_key) && (!kb_key(KB_SCAN_F12)))
    show_fps = !show_fps;

  if(kb_key(KB_SCAN_F12))
    show_key = TRUE;
  else
    show_key = FALSE;

  if((shot_key) && (!kb_key(KB_SCAN_F11))) {
    suspend_melee();
    save_screen_shot();
    resume_melee();
  }

  if(kb_key(KB_SCAN_F11))
    shot_key = TRUE;
  else
    shot_key = FALSE;

  if((esc_key) && (!kb_key(KB_SCAN_ESC))) {
    suspend_melee();
    font = desktop_font;
    if(alert("Game is paused", NULL, NULL, "&Abort game", "&Resume playing", 'a', 'r') == 1)
      melee_done = TRUE;
    font = (FONT *)(scppal[SCPPAL_FONT].dat);
    resume_melee();
  }

  if(kb_key(KB_SCAN_ESC))
    esc_key = TRUE;
  else
    esc_key = FALSE;

  if((music_key) && (!kb_key(KB_SCAN_F1))) {
    if(play_music) {
      play_music = FALSE;
      set_mod_volume(0);
    } else {
      play_music = TRUE;
      set_mod_volume(128);
    }
  }

  if(kb_key(KB_SCAN_F1))
    music_key = TRUE;
  else
    music_key = FALSE;

  if((zoom_key) && (!kb_key(KB_SCAN_F8)))
    zoom_discrete = !zoom_discrete;

  if(kb_key(KB_SCAN_F8))
    zoom_key = TRUE;
  else
    zoom_key = FALSE;

  if((antia_key) && (!kb_key(KB_SCAN_F7)))
    zoom_antia = !zoom_antia;

  if(kb_key(KB_SCAN_F7))
    antia_key = TRUE;
  else
    antia_key = FALSE;

  radar->erase();
  space->erase();

  stars->animate(space);
  spaceFrame->animate();
  panel1->animate();
  panel2->animate();

  if(show_fps) {
    sprintf(buf, "%d", fps);
    textout(space->frame, desktop_font, buf, 0, 0, pallete_color[15]);
    space->add_box(0, 0, 80, 8);
  }

  radar->draw();
  space->draw();

  frame_count++;
  return;
}

void play_melee(Player *_player1, Player *_player2)
{
  LOCK_VARIABLE(melee_time);
  LOCK_FUNCTION(melee_timer);

  LOCK_VARIABLE(frame_count);
  LOCK_VARIABLE(fps);
  LOCK_FUNCTION(fps_proc);

  melee_done = FALSE;
  i = random() % 3;

  set_config_file("scp.ini");

  total_frames = 1;
  timed_frames = 1;

  player1 = _player1;
  player1->init("Player1");

  player2 = _player2;
  player2->init("Player2");

  play_music = get_config_int("SCP", "PlayMusic", TRUE);
  if(play_music != 0)
    play_music = TRUE;

  set_pallete((PALLETE)(scppal[SCPPAL_PALLETE].dat));

  melee = load_datafile("melee.dat");
  if(!melee) {
    allegro_exit();
    printf("Error loading melee data\n");
    exit(1);
  }

  space = new Frame(0, 0, SCREEN_W - 64, SCREEN_H, MAX_SPACE_ITEMS);
  radar = new Frame(SCREEN_W - 60, SCREEN_H - 52, 56, 48, MAX_RADAR_ITEMS);

  stars = new Stars;

  asteroidSprite          = new SpaceSprite(&melee[MELEE_ASTEROID], ASTEROID_FRAMES);
  asteroidExplosionSprite = new SpaceSprite(&melee[MELEE_ASTEROIDEXPLOSION], ASTEROIDEXPLOSION_FRAMES);
  hotspotSprite           = new SpaceSprite(&melee[MELEE_HOTSPOT], HOTSPOT_FRAMES);
  kaboomSprite            = new SpaceSprite(&melee[MELEE_KABOOM], KABOOM_FRAMES);
  sparkSprite             = new SpaceSprite(&melee[MELEE_SPARK], SPARK_FRAMES);

  set_pallete((PALLETE)(scppal[i + 1].dat));
  gui_bg_color = pallete_color[0];
  gui_fg_color = pallete_color[15];
  set_dialog_color(selectDialog, pallete_color[0], pallete_color[15]);
  set_dialog_color(victoryDialog, pallete_color[0], pallete_color[15]);
  text_mode(-1);

  font = (FONT *)(scppal[SCPPAL_FONT].dat);

  spacePlanet = new Planet(new SpaceSprite(&melee[MELEE_PLANET + i], 1));
  spaceFrame = new SpaceFrame(space, radar, SPACE_LAYERS);

  spaceFrame->addSpaceObject(LAYER_CBODIES, spacePlanet);
  spaceFrame->addSpaceObject(LAYER_CBODIES, new Asteroid());
  spaceFrame->addSpaceObject(LAYER_CBODIES, new Asteroid());
  spaceFrame->addSpaceObject(LAYER_CBODIES, new Asteroid());
  spaceFrame->addSpaceObject(LAYER_CBODIES, new Asteroid());

  space_zoom   = 0.5;
  space_step   = 1;
  space_div    = 2;

  if(!play_music)
    set_mod_volume(0);
  else
    set_mod_volume(128);

  draw_rle_sprite(screen, (RLE_SPRITE *)(melee[MELEE_PANEL].dat),
    SCREEN_W - 64, SCREEN_H - 80);

  panel1 = NULL;
  panel2 = NULL;

  Ship *tracked_ship = NULL;

  int total_fleet1;
  int total_fleet2;
  int slot1;
  int slot2;
  int ship1;
  int ship2;

  load_fleet("scp.ini", "Fleet1");
  save_fleet("fleet1.tmp", "Fleet");
  total_fleet1 = fleet_cost;

  load_fleet("scp.ini", "Fleet2");
  save_fleet("fleet2.tmp", "Fleet");
  total_fleet2 = fleet_cost;

  install_keyboard();
  install_mouse();

  slot1 = select_fleet_ship(1, "fleet1.tmp", &panel1, total_fleet1);
  ship1 = ship_idtoindex(fleet_id[slot1]);
  player1->set_ship(panel1->ship, ship_info[ship1].reg->id);

  slot2 = select_fleet_ship(2, "fleet2.tmp", &panel2, total_fleet2);
  ship2 = ship_idtoindex(fleet_id[slot2]);
  player2->set_ship(panel2->ship, ship_info[ship2].reg->id);

  resume_melee();

  while(!melee_done) {
    melee_time   = 0;
    melee_paused = FALSE;
    frame_count  = 0;

    play_mod((JGMOD *)(melee[MELEE_MUSIC].dat), TRUE);

    install_int(melee_timer, 10);
    install_int(fps_proc, 1000);

    meleeVictory = NULL;

    while((!melee_done) && (panel1->exists()) && (panel2->exists())) {
      while(melee_time > 0) {
        play_frame();

        if(panel1->ship) panel1->ship->midpoint();
        if(panel2->ship) panel2->ship->midpoint();

      }

      animate_frame(stars);
    }

    stop_mod();

    space_zoom   = 1.0;
    space_step   = 0;
    space_div    = 1;
    tracked_ship = NULL;
    if(panel1->ship) tracked_ship = panel1->ship;
    if(panel2->ship) tracked_ship = panel2->ship;

    if(tracked_ship)
      tracked_ship->target = NULL;

    if(meleeVictory)
      play_mod(meleeVictory, FALSE);

    while((is_mod_playing()) && (!melee_done)) {
      while(melee_time > 0) {
        play_frame();

        tracked_ship = NULL;
        if(panel1->ship) tracked_ship = panel1->ship;
        if(panel2->ship) tracked_ship = panel2->ship;

        if(tracked_ship)
          tracked_ship->track();

      }
      animate_frame(stars);
    }

    stop_mod();

    remove_int(melee_timer);
    remove_int(fps_proc);

    suspend_melee();

    if(panel1->ship == NULL) {
      delete panel1;
      panel1 = NULL;
      load_fleet("fleet1.tmp", "Fleet");
      clear_fleet_slot(slot1);
      save_fleet("fleet1.tmp", "Fleet");
      slot1 = select_fleet_ship(1, "fleet1.tmp", &panel1, total_fleet1);
      ship1 = ship_idtoindex(fleet_id[slot1]);
      player1->set_ship(panel1->ship, ship_info[ship1].reg->id);
    }

    if(panel2->ship == NULL) {
      delete panel2;
      panel2 = NULL;
      load_fleet("fleet2.tmp", "Fleet");
      clear_fleet_slot(slot2);
      save_fleet("fleet2.tmp", "Fleet");
      slot2 = select_fleet_ship(2, "fleet2.tmp", &panel2, total_fleet2);
      ship2 = ship_idtoindex(fleet_id[slot2]);
      player2->set_ship(panel2->ship, ship_info[ship2].reg->id);
    }

    free_ships(ship1, ship2);

    load_fleet("fleet2.tmp", "Fleet");
    if(fleet_size == 0)
      show_fleet(1, "fleet1.tmp", total_fleet1, slot1);

    load_fleet("fleet1.tmp", "Fleet");
    if(fleet_size == 0)
      show_fleet(2, "fleet2.tmp", total_fleet2, slot2);

    resume_melee();
  }

  player1->deinit();
  player2->deinit();

  delete_file("fleet1.tmp");
  delete_file("fleet2.tmp");

  clear(screen);

  if(panel1) delete panel1;
  if(panel2) delete panel2;

  free_ships(-1, -1);

  delete asteroidSprite;
  delete asteroidExplosionSprite;
  delete hotspotSprite;
  delete kaboomSprite;
  delete sparkSprite;
  delete spaceFrame;

  unload_datafile(melee);

  set_mod_volume(255);

  kb_remove();

  delete radar;
  delete space;
}

void suspend_melee()
{
  gui_bg_color = pallete_color[15];
  gui_fg_color = pallete_color[0];
  melee_paused = TRUE;
  kb_remove();
  install_keyboard();
  install_mouse();
}

void resume_melee()
{
  text_mode(-1);
  clear_to_color(screen, pallete_color[0]);
  space->add_box(0, 0, 576, 480);
  radar->add_box(0, 0, 56, 48);
  if((panel1) && (panel1->ship))
    panel1->refresh(0);
  if((panel2) && (panel2->ship))
    panel2->refresh(1);
  draw_rle_sprite(screen, (RLE_SPRITE *)(melee[MELEE_PANEL].dat),
    SCREEN_W - 64, SCREEN_H - 80);
  remove_keyboard();
  remove_mouse();
  kb_install(0);
  melee_paused = FALSE;
}

int select_fleet_ship(int player, char *fleet_file, ShipPanel **panel,
  int fleet_total)
{
  int ret, slot = 0;

  if(((*panel) != NULL) || (melee_done))
    return(-1);

  load_fleet(fleet_file, "Fleet");
  if(fleet_size == 0) {
    melee_done = TRUE;
    return(-1);
  }

  if(player == 1)
    sprintf(selectPlayer, "Player One Fleet");
  else
    sprintf(selectPlayer, "Player Two Fleet");

  sprintf(selectTitleString, "%s\n%d of %d points", fleet_title, fleet_cost, fleet_total);
  ret = do_dialog(selectDialog, SELECT_DIALOG_LIST);
  if((ret == SELECT_DIALOG_SHIP) || (ret == SELECT_DIALOG_LIST))
    slot = selectDialog[SELECT_DIALOG_LIST].d1;
  if(ret == SELECT_DIALOG_RANDOM)
    slot = random() % fleet_size;
  if((ret == SELECT_DIALOG_ABORT) || (ret == -1)) {
    melee_done = TRUE;
    return(-1);
  }

  (*panel) = select_ship(player, ship_idtoindex(fleet_id[slot]));
  (*panel)->ship->locate();
  spaceFrame->addSpaceObject(LAYER_SHIPS, (*panel)->ship);

  return(slot);
}

void save_screen_shot()
{
  static int shot_index = 0;

  BITMAP *bmp;
  PALLETE pal;

  char path[80];

  get_pallete(pal);
  bmp = create_bitmap(SCREEN_W, SCREEN_H);
  blit(screen, bmp, 0, 0, 0, 0, SCREEN_W, SCREEN_H);

  if(shot_index < 10000) {
    sprintf(path, "scrshots\\shot%04d.pcx", shot_index);
    while(exists(path)) {
      shot_index++;
      sprintf(path, "scrshots\\shot%04d.pcx", shot_index);
    }
  } else
    sprintf(path, "scrshots\\");

  font = desktop_font;
  if(file_select("Save screen shot", path, "BMP;PCX;TGA"))
    save_bitmap(path, bmp, pal);

  destroy_bitmap(bmp);
  font = (FONT *)(scppal[SCPPAL_FONT].dat);
}

void show_fleet(int player, char *fleet_file, int fleet_total, int slot)
{
  load_fleet(fleet_file, "Fleet");

  if(player == 1)
    sprintf(selectPlayer, "Player One Fleet");
  else
    sprintf(selectPlayer, "Player Two Fleet");

  sprintf(selectTitleString, "%s\n%d of %d points", fleet_title, fleet_cost, fleet_total);
  victoryDialog[VICTORY_DIALOG_LIST].d1 = slot;
  do_dialog(victoryDialog, VICTORY_DIALOG_CONTINUE);
}

void register_ship(SHIP_REGISTER_INFO *reg_info)
{
  if(num_ship_types >= MAX_SHIP_TYPES)
    return;

  char fn[28];

  fn[0] = '\0';
  strcat(fn, "ships\\shp");
  strcat(fn, reg_info->id);
  strcat(fn, ".dat");

  if(!exists(fn))
    return;

  ship_info[num_ship_types].reg = reg_info;
  ship_info[num_ship_types].dat = NULL;

  strcat(fn, "#SHIP_DAT");
  set_config_file(fn);
  ship_info[num_ship_types].cost = get_config_int("Ship", "Cost", 0);

  num_ship_types++;
}

char shipSelection[80];

char *shipListboxGetter(int index, int *list_size)
{
  if(index < 0) {
    *list_size = num_ship_types;
    return NULL;
  } else {
    sprintf(shipSelection, "%s %d", ship_name[index], ship_info[index].cost);
    return shipSelection;
  }
}

void init_fleet()
{
  int i;

  for(i = 0; i < MAX_FLEET_SIZE; i++) {
    fleet_id[i] = strEmptySlotID;
    fleet_name[i] = strEmptySlotName;
  }

  fleet_size = 0;
  fleet_cost = 0;
  sprintf(fleet_title, "Untitled");
}

void select_fleet_slot(int slot, int ship_index)
{
  if(fleet_id[slot] == strEmptySlotID)
    fleet_size++;
  else
    fleet_cost -= ship_info[ship_idtoindex(fleet_id[slot])].cost;

  fleet_cost += ship_info[ship_index].cost;

  fleet_id[slot] = ship_info[ship_index].reg->id;
  fleet_name[slot] = ship_info[ship_index].reg->name;
}

void clear_fleet_slot(int slot)
{
  if(fleet_id[slot] == strEmptySlotID)
    return;

  fleet_cost -= ship_info[ship_idtoindex(fleet_id[slot])].cost;
  fleet_id[slot] = strEmptySlotID;
  fleet_name[slot] = strEmptySlotName;
  fleet_size--;
}

void save_fleet(char *filename, char *section)
{
  int i, count = 0;
  char slot_str[8];

  set_config_file(filename);

  for(i = 0; i < MAX_FLEET_SIZE; i++) {
    if(strcmp(fleet_id[i], strEmptySlotID) != 0) {
      sprintf(slot_str, "Slot%d", count);
      set_config_string(section, slot_str, fleet_id[i]);
      count++;
    }
  }

  for(i = count; i < MAX_FLEET_SIZE; i++) {
    sprintf(slot_str, "Slot%d", i);
    set_config_string(section, slot_str, NULL);
  }

  set_config_int(section, "Size", count);
  set_config_string(section, "Title", fleet_title);

  // to force saved SCF files to be written
  set_config_file("scp.ini");
}

int ship_idtoindex(char *id_str)
{
  int i = 0, found = FALSE;

  while((i < num_ship_types) && (!found)) {
    if(strcmp(id_str, ship_info[i].reg->id) == 0)
      found = TRUE;
    else
      i++;
  }

  if(found)
    return(i);
  else
    return(-1);
}

void load_fleet(char *filename, char *section)
{
  int i, count, ship_index;
  char slot_str[8], *slot_id, *title;

  init_fleet();

  set_config_file(filename);
  count = get_config_int(section, "Size", 0);
  title = get_config_string(section, "Title", "");
  sprintf(fleet_title, title);

  for(i = 0; i < count; i++) {
    sprintf(slot_str, "Slot%d", i);
    slot_id = get_config_string(section, slot_str, "?????");
    ship_index = ship_idtoindex(slot_id);
    if(ship_index >= 0)
      select_fleet_slot(i, ship_index);
  }

  fleet_size = count;
}

char *fleetListboxGetter(int index, int *list_size)
{
  if(index < 0) {
    *list_size = MAX_FLEET_SIZE;
    return NULL;
  } else
    return fleet_name[index];
}

char *selectListboxGetter(int index, int *list_size)
{
  if(index < 0) {
    *list_size = fleet_size;
    return NULL;
  } else
    return fleet_name[index];
}

void load_ship_data(int index)
{
  if(ship_info[index].dat != NULL)
    return;

  char fn[19];

  fn[0] = '\0';
  strcat(fn, "ships\\shp");
  strcat(fn, ship_info[index].reg->id);
  strcat(fn, ".dat");

  ship_info[index].dat = new ShipData(fn);
}

void init_ships()
{
  int i;

  num_ship_types = 0;

  #include "../ships.h"

  if(num_ship_types == 0) {
    allegro_exit();
    printf("No ship data available.\n");
    exit(1);
  }

  for(i = 0; i < num_ship_types; i++)
    ship_name[i] = ship_info[i].reg->name;
}

void free_ships(int ship1, int ship2)
{
  int i;

  for(i = 0; i < num_ship_types; i++)
    if((ship_info[i].dat != NULL) && (i != ship1) && (i != ship2)) {
      delete ship_info[i].dat;
      ship_info[i].dat = NULL;
    }
}

ShipPanel *select_ship(int player, int index)
{
  int    radar_color = RADAR_COLOR_FRIEND;
  double angle, x, y;

  if(player != 1)
    radar_color = RADAR_COLOR_ENEMY;

  x = (double)(random() % (long)(X_MAX));
  y = (double)(random() % (long)(Y_MAX));
  angle = (double)(random() % 64) * 5.625;

  load_ship_data(index);

  return(new ShipPanel(
    ship_info[index].reg->getShip(x, y, angle, player, radar_color,
      ship_info[index].dat), player - 1));
}