#include <math.h>
#include <kb.h>
#include <string.h>

#include <lsck/lsck.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <fcntl.h>

#include "../melee.h"
#include "../player.h"
#include "../ai.h"

void Player::init(char *n) {
  ai = NULL;
  type = get_config_int(n, "AI", 0);
  }
void Player::deinit() {
  if (ai) delete ai;
  ai = NULL;
  }
void Player::set_ship(Ship *ship, char *n) {
  s = ship;
  switch (type) {
    case 2:
      if (ai) delete ai;
      ai = init_ai(ship, n);
      break;
    default:
      break;
    }
  return;
  }
void Player::load(char *initfile, char *section) {
  set_config_file(initfile);
  name     = strdup(section);
  type       = abs( get_config_int(section, "Type", 0)) % num_bots;
  k_thrust   = get_config_int   (section, "Thrust", 0);
  k_left     = get_config_int   (section, "TurnLeft", 0);
  k_right    = get_config_int   (section, "TurnRight", 0);
  k_fire     = get_config_int   (section, "FireWeapon", 0);
  k_special  = get_config_int   (section, "FireSpecial", 0);
  return;
  }
void Player::save(char *initfile, char *section) {
  set_config_file(initfile);
  set_config_int   (section, "Type", type);
  set_config_int   (section, "Thrust", k_thrust);
  set_config_int   (section, "TurnLeft", k_left);
  set_config_int   (section, "TurnRight", k_right);
  set_config_int   (section, "FireWeapon", k_fire);
  set_config_int   (section, "FireSpecial", k_special);
  return;
  }
int Player::human () {
  int r;
  r = 0;
  if (kb_key(k_thrust)) r |= keyflag::thrust;
  if (kb_key(k_left)) r |= keyflag::left;
  if (kb_key(k_right)) r |= keyflag::right;
  if (kb_key(k_fire)) r |= keyflag::fire;
  if (kb_key(k_special)) r |= keyflag::special;
  return r;
  }
int Player::bot () {
  double a;
  int r = 0;
  if (!s) return r;
  if (!s->target) return r;
  a = s->trajectory_angle(s->target) - s->get_angle();
  a = fmod(a + 360, 360);
  if (a < 180) {
    r |= keyflag::right;
    }
  else {
    r |= keyflag::left;
    return r;
    }
  a = int(s->distance(s->target));
  if (a > 2000) {
    r |= keyflag::thrust;
    }
  else {
    r |= keyflag::thrust;
    r |= keyflag::fire;
    }
  return r;
  }
void Player::act(int a) {
  int i;
  i = s->nextkeys;
  s->nextkeys = a;
  s->thrust       = 1&&(i & keyflag::thrust);
  s->turn_left    = 1&&(i & keyflag::left);
  s->turn_right   = 1&&(i & keyflag::right);
  s->fire_weapon  = 1&&(i & keyflag::fire);
  s->fire_special = 1&&(i & keyflag::special);
  return;
  }
void Player::calculate () {
  unsigned int action = 0;
  switch (type) {
    case 2:
      if (ai) {
        ai->calculate();
        action = ai->k.convert();
        }
      else action = bot();
      break;
    case 1:
      action = bot();
      break;
    case 0:
      action = human();
      break;
    }        
  act(action);
  return;
  }

